# coding: utf-8

"""
    Trieve API

    Trieve OpenAPI Specification. This document describes all of the operations available through the Trieve API.

    The version of the OpenAPI document: 0.12.0
    Contact: developers@trieve.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from trieve_py_client.models.add_to_cart import AddToCart
from trieve_py_client.models.click import Click
from trieve_py_client.models.filter_clicked import FilterClicked
from trieve_py_client.models.purchase import Purchase
from trieve_py_client.models.rag import RAG
from trieve_py_client.models.recommendation import Recommendation
from trieve_py_client.models.search import Search
from trieve_py_client.models.view import View
from pydantic import StrictStr, Field
from typing import Union, List, Optional, Dict
from typing_extensions import Literal, Self

EVENTTYPES_ONE_OF_SCHEMAS = ["AddToCart", "Click", "FilterClicked", "Purchase", "RAG", "Recommendation", "Search", "View"]

class EventTypes(BaseModel):
    """
    EventTypes
    """
    # data type: View
    oneof_schema_1_validator: Optional[View] = None
    # data type: AddToCart
    oneof_schema_2_validator: Optional[AddToCart] = None
    # data type: Click
    oneof_schema_3_validator: Optional[Click] = None
    # data type: Purchase
    oneof_schema_4_validator: Optional[Purchase] = None
    # data type: FilterClicked
    oneof_schema_5_validator: Optional[FilterClicked] = None
    # data type: Search
    oneof_schema_6_validator: Optional[Search] = None
    # data type: RAG
    oneof_schema_7_validator: Optional[RAG] = None
    # data type: Recommendation
    oneof_schema_8_validator: Optional[Recommendation] = None
    actual_instance: Optional[Union[AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View]] = None
    one_of_schemas: List[str] = Field(default=Literal["AddToCart", "Click", "FilterClicked", "Purchase", "RAG", "Recommendation", "Search", "View"])

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = EventTypes.model_construct()
        error_messages = []
        match = 0
        # validate data type: View
        if not isinstance(v, View):
            error_messages.append(f"Error! Input type `{type(v)}` is not `View`")
        else:
            match += 1
        # validate data type: AddToCart
        if not isinstance(v, AddToCart):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AddToCart`")
        else:
            match += 1
        # validate data type: Click
        if not isinstance(v, Click):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Click`")
        else:
            match += 1
        # validate data type: Purchase
        if not isinstance(v, Purchase):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Purchase`")
        else:
            match += 1
        # validate data type: FilterClicked
        if not isinstance(v, FilterClicked):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FilterClicked`")
        else:
            match += 1
        # validate data type: Search
        if not isinstance(v, Search):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Search`")
        else:
            match += 1
        # validate data type: RAG
        if not isinstance(v, RAG):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RAG`")
        else:
            match += 1
        # validate data type: Recommendation
        if not isinstance(v, Recommendation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Recommendation`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in EventTypes with oneOf schemas: AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in EventTypes with oneOf schemas: AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into View
        try:
            instance.actual_instance = View.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AddToCart
        try:
            instance.actual_instance = AddToCart.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Click
        try:
            instance.actual_instance = Click.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Purchase
        try:
            instance.actual_instance = Purchase.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into FilterClicked
        try:
            instance.actual_instance = FilterClicked.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Search
        try:
            instance.actual_instance = Search.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RAG
        try:
            instance.actual_instance = RAG.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into Recommendation
        try:
            instance.actual_instance = Recommendation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into EventTypes with oneOf schemas: AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into EventTypes with oneOf schemas: AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AddToCart, Click, FilterClicked, Purchase, RAG, Recommendation, Search, View]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


