# coding: utf-8

"""
    Trieve API

    Trieve OpenAPI Specification. This document describes all of the operations available through the Trieve API.

    The version of the OpenAPI document: 0.12.0
    Contact: developers@trieve.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from trieve_py_client.models.clickhouse_recommendation_types import ClickhouseRecommendationTypes
from typing import Optional, Set
from typing_extensions import Self

class Recommendation(BaseModel):
    """
    Recommendation
    """ # noqa: E501
    event_type: StrictStr
    negative_ids: Optional[List[StrictStr]] = Field(default=None, description="Negative ids used for the recommendation")
    negative_tracking_ids: Optional[List[StrictStr]] = Field(default=None, description="Negative tracking ids used for the recommendation")
    positive_ids: Optional[List[StrictStr]] = Field(default=None, description="Positive ids used for the recommendation")
    positive_tracking_ids: Optional[List[StrictStr]] = Field(default=None, description="Positive tracking ids used for the recommendation")
    recommendation_type: Optional[ClickhouseRecommendationTypes] = None
    request_params: Optional[Any] = Field(default=None, description="The request params of the recommendation")
    results: Optional[List[Any]] = Field(default=None, description="The results of the Recommendation event")
    top_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Top score of the recommendation")
    user_id: Optional[StrictStr] = Field(default=None, description="The user id of the user who made the recommendation")
    __properties: ClassVar[List[str]] = ["event_type", "negative_ids", "negative_tracking_ids", "positive_ids", "positive_tracking_ids", "recommendation_type", "request_params", "results", "top_score", "user_id"]

    @field_validator('event_type')
    def event_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['recommendation']):
            raise ValueError("must be one of enum values ('recommendation')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Recommendation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if negative_ids (nullable) is None
        # and model_fields_set contains the field
        if self.negative_ids is None and "negative_ids" in self.model_fields_set:
            _dict['negative_ids'] = None

        # set to None if negative_tracking_ids (nullable) is None
        # and model_fields_set contains the field
        if self.negative_tracking_ids is None and "negative_tracking_ids" in self.model_fields_set:
            _dict['negative_tracking_ids'] = None

        # set to None if positive_ids (nullable) is None
        # and model_fields_set contains the field
        if self.positive_ids is None and "positive_ids" in self.model_fields_set:
            _dict['positive_ids'] = None

        # set to None if positive_tracking_ids (nullable) is None
        # and model_fields_set contains the field
        if self.positive_tracking_ids is None and "positive_tracking_ids" in self.model_fields_set:
            _dict['positive_tracking_ids'] = None

        # set to None if recommendation_type (nullable) is None
        # and model_fields_set contains the field
        if self.recommendation_type is None and "recommendation_type" in self.model_fields_set:
            _dict['recommendation_type'] = None

        # set to None if request_params (nullable) is None
        # and model_fields_set contains the field
        if self.request_params is None and "request_params" in self.model_fields_set:
            _dict['request_params'] = None

        # set to None if results (nullable) is None
        # and model_fields_set contains the field
        if self.results is None and "results" in self.model_fields_set:
            _dict['results'] = None

        # set to None if top_score (nullable) is None
        # and model_fields_set contains the field
        if self.top_score is None and "top_score" in self.model_fields_set:
            _dict['top_score'] = None

        # set to None if user_id (nullable) is None
        # and model_fields_set contains the field
        if self.user_id is None and "user_id" in self.model_fields_set:
            _dict['user_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Recommendation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "event_type": obj.get("event_type"),
            "negative_ids": obj.get("negative_ids"),
            "negative_tracking_ids": obj.get("negative_tracking_ids"),
            "positive_ids": obj.get("positive_ids"),
            "positive_tracking_ids": obj.get("positive_tracking_ids"),
            "recommendation_type": obj.get("recommendation_type"),
            "request_params": obj.get("request_params"),
            "results": obj.get("results"),
            "top_score": obj.get("top_score"),
            "user_id": obj.get("user_id")
        })
        return _obj


