# coding: utf-8

"""
    Trieve API

    Trieve OpenAPI Specification. This document describes all of the operations available through the Trieve API.

    The version of the OpenAPI document: 0.12.0
    Contact: developers@trieve.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from trieve_py_client.models.low_confidence_recommendations import LowConfidenceRecommendations
from trieve_py_client.models.query_details1 import QueryDetails1
from trieve_py_client.models.recommendation_queries import RecommendationQueries
from pydantic import StrictStr, Field
from typing import Union, List, Optional, Dict
from typing_extensions import Literal, Self

RECOMMENDATIONANALYTICS_ONE_OF_SCHEMAS = ["LowConfidenceRecommendations", "QueryDetails1", "RecommendationQueries"]

class RecommendationAnalytics(BaseModel):
    """
    RecommendationAnalytics
    """
    # data type: LowConfidenceRecommendations
    oneof_schema_1_validator: Optional[LowConfidenceRecommendations] = None
    # data type: RecommendationQueries
    oneof_schema_2_validator: Optional[RecommendationQueries] = None
    # data type: QueryDetails1
    oneof_schema_3_validator: Optional[QueryDetails1] = None
    actual_instance: Optional[Union[LowConfidenceRecommendations, QueryDetails1, RecommendationQueries]] = None
    one_of_schemas: List[str] = Field(default=Literal["LowConfidenceRecommendations", "QueryDetails1", "RecommendationQueries"])

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = RecommendationAnalytics.model_construct()
        error_messages = []
        match = 0
        # validate data type: LowConfidenceRecommendations
        if not isinstance(v, LowConfidenceRecommendations):
            error_messages.append(f"Error! Input type `{type(v)}` is not `LowConfidenceRecommendations`")
        else:
            match += 1
        # validate data type: RecommendationQueries
        if not isinstance(v, RecommendationQueries):
            error_messages.append(f"Error! Input type `{type(v)}` is not `RecommendationQueries`")
        else:
            match += 1
        # validate data type: QueryDetails1
        if not isinstance(v, QueryDetails1):
            error_messages.append(f"Error! Input type `{type(v)}` is not `QueryDetails1`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in RecommendationAnalytics with oneOf schemas: LowConfidenceRecommendations, QueryDetails1, RecommendationQueries. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in RecommendationAnalytics with oneOf schemas: LowConfidenceRecommendations, QueryDetails1, RecommendationQueries. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into LowConfidenceRecommendations
        try:
            instance.actual_instance = LowConfidenceRecommendations.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into RecommendationQueries
        try:
            instance.actual_instance = RecommendationQueries.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into QueryDetails1
        try:
            instance.actual_instance = QueryDetails1.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RecommendationAnalytics with oneOf schemas: LowConfidenceRecommendations, QueryDetails1, RecommendationQueries. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RecommendationAnalytics with oneOf schemas: LowConfidenceRecommendations, QueryDetails1, RecommendationQueries. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], LowConfidenceRecommendations, QueryDetails1, RecommendationQueries]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


